; parse the results of a question to the facts base
(deffunction parse (?input)
             (bind ?exploded (explode$ ?input))
             (loop-for-count (?cnt 1 (length$ ?exploded)) do
                     (assert (file ?exploded ?cnt))
             )
)

; ask a question and parse the answer
(deffunction ask (?question)
             (printout t ?question crlf)
             (bind ?response (readline t))
             (return ?response)
)

; ask the user for a output from a gate, so that could only be 0 or 1
; also the user may choose to interrupt this testing and state that he
; has replaced a certain gate
(deffunction askTest (?question)
             (printout t ?question crlf)
             (bind ?response (readline t))
             (if (or (eq ?response "1") (eq ?response "0") (eq ?response "replace") (eq ?response "stop") (eq ?response "doom"))
                 then (return ?response)
                 else (printout t "Please respond with 0 or 1." crlf)
                      (return (askTest ?question))
             )
             (return ?response)
)